﻿BetterSocialTooltip = LibStub("AceAddon-3.0"):NewAddon("BetterSocialTooltip", "AceHook-3.0");
local L = LibStub("AceLocale-3.0"):GetLocale("BetterSocialTooltip", true);

function BetterSocialTooltip:OnInitialize()
	-- do nothing
end

function BetterSocialTooltip:OnEnable()
	self:SecureHookScript(FriendsMicroButton, "OnEnter", "OnMouseOver");
end

function BetterSocialTooltip:OnDisable()
	self:UnHookAll();
end

function BetterSocialTooltip:OnMouseOver()
	local numBNetFriends, numBNetOnline = BNGetNumFriends();
	local numWoWFriends, numWoWOnline = GetNumFriends();
	local sMsg = "";
	
	if (numBNetOnline + numWoWOnline) == 1 then
		sMsg = L["friend_msg_singular"];
	else
		sMsg = string.format(L["friend_msg_plural"], (numBNetOnline + numWoWOnline));
	end
	GameTooltip:AddLine(sMsg, 0, 1, 0);
	-- Battle.net Friends
	for i = 1, numBNetFriends, 1 do
		--local sPresenceID, sNameFirst, sNameLast, sCharName, sCharID, sClient, bIsOnline = BNGetFriendInfo(i);
		local sPresenceID, sRealName, _, _, sCharName, sCharID, sClient, bIsOnline = BNGetFriendInfo(i);
		if bIsOnline then
			local sArea = sClient;
			if sClient == "WoW" then
				local _, _, _, sServer = BNGetToonInfo(sPresenceID);
				sArea = sServer;
			end
			GameTooltip:AddLine(sCharName .. " (" .. sArea .. ") [" .. sRealName .. "]", 0, 1, 1 );
		end
	end
	-- Regular Friends
	for i = 1, numWoWFriends, 1 do
		local sName, iLevel, sClass, sArea, bConnected, sNote, fStatus = GetFriendInfo(i);
		if bConnected then
			GameTooltip:AddLine(sName, 1, 1, 1);
		end
	end
	GameTooltip:Show();
end